unit M45Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, M45Thr,M45Dial;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    SpellGroup: TGroupBox;
    StartBtn: TButton;
    StopBtn: TButton;
    Panel2: TPanel;
    ProgressBar: TProgressBar;
    Memo: TMemo;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    LoadBtn: TButton;
    SaveBtn: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ExitBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    text:String;
    batch:boolean;
    slovnik:TSortStringList;
    SpellThread:TSpellThread;
    procedure UpdateVcl;
    procedure OnThreadEnds(Sender:TObject);
    procedure OnError(sender:TObject;s:string;var slovo:string);
    procedure addcallback(s:string);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.addcallback(s:string);
var p,d:integer;
begin
  d:=slovnik.Add(s);
  p:=pos('/',slovnik.Strings[d]);
    if p<>0 then slovnik.Strings[d]:=copy(slovnik.Strings[d],1,p-1);
  slovnik.sort;
end;

procedure TMainForm.OnThreadEnds(Sender:TObject);
begin
  Memo.text:=Text;
  if batch then begin
                  Memo.Lines.SaveToFile(paramstr(2));
                  close;
                end
           else begin
                  showmessage('Kontrola pravopisu skonena');
                  if not MyDialog.cancel then saveBtn.Click;
                end;
  updatevcl;
end;

procedure TMainForm.OnError(sender:TObject;s:string;var slovo:string);
begin
  MyDialog.addCallback:=addcallback;
  slovo:=MyDialog.Execute(s,slovo,slovnik);
  if MyDialog.cancel then SpellThread.stop;
  updatevcl;
end;

procedure TMainForm.UpdateVcl;
begin
  StartBtn.Enabled:=SpellThread.suspended;
  StopBtn.Enabled:=not SpellThread.suspended;
  ProgressBar.position:=SpellThread.position;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var d,p:integer;
begin
  batch:=false;
  slovnik:=TSortStringList.Create;
  slovnik.LoadFromFile('dict.txt');
  for d:=0 to slovnik.count-1 do
  begin
    p:=pos('/',slovnik.Strings[d]);
    if p<>0 then slovnik.Strings[d]:=copy(slovnik.Strings[d],1,p-1);
  end;
  SpellThread:=TSpellThread.Create(true);
  SpellThread.OnThreadEnds:=OnThreadEnds;
  updateVcl;

  if paramcount>=2
    then begin
           Memo.Lines.LoadFromFile(paramstr(1));
           batch:=true;
           text:=Memo.Lines.Text;
           SpellThread.start(@text,slovnik);
           updatevcl;
         end
    else begin
           SpellThread.FirstError:=true;
           SpellThread.OnError:=OnError;
         end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SpellThread.Terminate;
  SpellThread.resume;
  SpellThread.Waitfor;
  SpellThread.Free;
  slovnik.free;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  updatevcl;
end;

procedure TMainForm.StartBtnClick(Sender: TObject);
begin
  text:=Memo.Lines.Text;
  SpellThread.start(@text,slovnik);
  updatevcl;
end;

procedure TMainForm.StopBtnClick(Sender: TObject);
begin
  SpellThread.Stop;
  updatevcl;
end;

procedure TMainForm.LoadBtnClick(Sender: TObject);
begin
  if OpenDialog.Execute then Memo.Lines.Loadfromfile(OpenDialog.filename);
end;

procedure TMainForm.SaveBtnClick(Sender: TObject);
begin
  if SaveDialog.Execute then Memo.Lines.SaveTofile(SaveDialog.filename);
end;

procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  close;
end;

end.
