unit M45Thr;

interface

uses
  Classes, sysutils;

const whitechar:set of char=[#0..#64,#91..#96,#123..#127];
      okoli=100;
      tolerance=4;
      lenkoef=3;
      cetnkoef=2;
      poskoef=1;

type
  TSortStringList = class(TStringlist)
                      function indexof(const S: string): Integer; override;
                      procedure findpodobna(const s:string;List:TStrings);
                    end;

  PString=^String;
  TSpellThread = class(TThread)
  private
    { Private declarations }
    s,slovo:string;
    procedure error;
    procedure endspell;
  protected
    stopped:boolean;
    Text:PString;
    pos,len:integer;
    slovnik:TStringlist;
    procedure Execute; override;
  public
    firsterror:boolean;
    OnThreadEnds:TNotifyEvent;
    OnError:procedure(sender:TObject;s:string;var slovo:string) of Object;
    procedure start(text:PString;slovnik:TSortStringList);
    procedure stop;
    function position:integer;
  end;

implementation

function TSortstringlist.indexof(const S: string): Integer;
var min,max,med,comp:integer;
begin
  min:=0;max:=count-1;
  while min<max do
  begin
    med:=(min+max) div 2;
    comp:=AnsiCompareStr(uppercase(S), uppercase(strings[med]));
    if comp>0 then min:=med+1
    else if comp<0 then max:=med-1
    else begin
           result:=med;
           exit;
         end;
  end;
  if (min=max) and (s=strings[min])
    then result:=min
    else result:=-1;
end;      // binarni vyhledavani

procedure TSortstringlist.findpodobna(const s:string;List:TStrings);
type Tcharcount=array[char] of record
                                 cetn:integer;  // cetnost znaku
                                 pos:integer;   // pozice
                               end;

var d,m,n,b,len:integer;
    cc1,cc2:Tcharcount;

procedure countchars(const s:string;var c:TCharCount);
var d,m,s1,s2:integer;
begin
  fillchar(c,sizeof(c),0);
    for m:=0 to length(s) do
    begin
      inc(c[s[m]].cetn);
      inc(c[s[m]].pos,m);
    end;
end;

begin
  List.clear;
  countchars(s,cc1);
  for d:=0 to count-1 do
  begin
    len:=length(s);
    countchars(strings[d],cc2);
    b:=abs(length(s)-length(strings[d]))*lenkoef;
      for m:=0 to 255 do
      begin
        b:=b+abs(cc2[char(m)].cetn-cc1[char(m)].cetn)*cetnkoef;
        b:=b+abs(cc2[char(m)].pos*poskoef-cc1[char(m)].pos*poskoef);
        if b>tolerance*len then break;
      end;
    if b<=tolerance*len then List.add(strings[d]);
  end;
end;


function readslovo(const s:string;var start,pos:integer;len:integer):string;
begin
  result:='';
  while (pos<=len) and (s[pos] in whitechar) do inc(pos);
  start:=pos;
  while (pos<=len) and not (s[pos] in whitechar) do begin
                                                      result:=result+s[pos];
                                                      inc(pos);
                                                    end;
end;

{ Important: Methods and properties of objects in VCL can only be used in a
  method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TMainThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TMainThread }

procedure TSpellThread.error;
begin
  if @OnError<>nil then OnError(self,s,slovo);
end;

procedure TSpellThread.endspell;
begin
  if @OnThreadEnds<>nil then OnThreadEnds(self);
end;

procedure TSpellThread.Execute;
var s,slovo:string;
    d,m:integer;
    lpos:integer;
begin
  { Place thread code here }
  repeat
    while (pos<=len) do
    begin
      slovo:=readslovo(text^,lpos,pos,len);
      if slovo<>'' then
      if slovnik.indexof(slovo)=-1 then begin
                                          if not firsterror
                                            then begin
                                                   insert('#',text^,lpos);
                                                   inc(len);
                                                   inc(pos);
                                                 end
                                            else begin
                                                   delete(text^,lpos,pos-lpos);
                                                   len:=len-pos+lpos;
                                                   d:=lpos-okoli;if d<1 then d:=1;
                                                   s:=copy(text^,d,lpos-d)+'<'+slovo+'>'+copy(text^,lpos,okoli);
                                                   self.s:=s;
                                                   self.slovo:=slovo;  { zaloha kvuli synchronize }
                                                   synchronize(error);
                                                   insert(self.slovo,text^,lpos);
                                                   len:=len+length(slovo);
                                                   pos:=lpos;
                                                 end;
                                        end;
      if stopped then break;
      if terminated then exit;
    end;
    synchronize(endspell);

    if terminated then exit;
    suspend;
  until terminated;
end;

procedure TSpellThread.start(text:PString;slovnik:TSortStringList);
begin
  self.text:=text;
  self.len:=length(text^);
  self.pos:=1;
  self.slovnik:=slovnik;
  self.stopped:=false;
  slovnik.sort;              // pro binarni vyhledavani
  resume;
end;

procedure TSpellThread.Stop;
begin;
  stopped:=true;
end;

function TSpellThread.position:integer;
begin
  if suspended then result:=0
               else if len=0 then result:=0
                             else result:=pos*100 div len;
end;

end.
